<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class Balance extends \Zeedhi\Framework\Controller\Simple {

    protected $balanceService;
    protected $snackMessage;
    protected $util;

    public function __construct(\Service\Balance $balanceService, \Util\SnackMessage $snackMessage, \Util\Util $util){
        $this->balanceService = $balanceService;
        $this->snackMessage = $snackMessage;
        $this->util = $util;
    }

    public function getBalance(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $CDCLIENTE    = $params[0]['value'];
            $CDCONSUMIDOR = $params[1]['value'];
            $CDFILIAL     = $params[2]['value'];

            $consumerBalance = $this->balanceService->getBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFILIAL);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('BalanceRepository', $consumerBalance));

        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    // public function getConsumersBalance(Request\Filter $request, Response $response){
    //     try {
    //         $params = $request->getFilterCriteria()->getConditions();

    //         $CDCLIENTE    = $params[0]['value'];
    //         $NRCPFRESPCON = $params[1]['value'];

    //         $consumersBalance = $this->balanceService->getConsumersBalance($CDCLIENTE, $NRCPFRESPCON);
    //         var_dump($consumersBalance); die();
    //         $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('RealoadRepository', $consumersBalance));
    //     } catch (\Exception $e){
    //         $response->addMessage(new Message($e->getMessage()));
    //     }
    // }

}