<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class DayDetails extends \Zeedhi\Framework\Controller\Simple {

    protected $dayDetailsService;
    protected $snackMessage;
    protected $util;

    public function __construct(\Service\DayDetails $dayDetailsService, \Util\SnackMessage $snackMessage, \Util\Util $util){
        $this->dayDetailsService = $dayDetailsService;
        $this->snackMessage = $snackMessage;
        $this->util = $util;
    }

    public function getGroupedProductsByDay(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            
            $CDCLIENTE    = $params[0]['value'];
            $CDCONSUMIDOR = $params[1]['value'];
            $DTINI        = $params[2]['value'];
            $DTFIM        = $params[3]['value'];

            $list = $this->dayDetailsService->getGroupedProductsByDay($CDCLIENTE, $CDCONSUMIDOR, $DTINI, $DTFIM);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('GroupedProductsByDayRepository', $list));
        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }   
    }

    public function getProductNutritionalInformations(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $CDPRODUTO = $params[0]['value'];
            $FATORCOMPOSICAO = 1;
            $list = $this->dayDetailsService->getProductNutrients($CDPRODUTO, $FATORCOMPOSICAO);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ProductNutritionalInformationsRepository', $list));
        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }   
    }

}    