<?php
namespace Helpers;

use Zeedhi\Framework\Session\Session;

class Environment {

    const USER_UNIQUE_ID = 'USERID';
    const USER_ID_KEY = 'CDCONSUMIDOR';
    const USER_CPF_KEY = 'NRCPFRESPCON';
    const USER_CLIENT_KEY = 'CDCLIENTE';

    protected $session;

    public function __construct(Session $session) {
        $this->session = $session;
    }

    public function setUniqueUserId($userId) {
        self::startSession();
        $this->session->set(self::USER_UNIQUE_ID, $userId);
    }

    public function getUniqueUserId() {
        return $this->session->get(self::USER_UNIQUE_ID);
    }

    public function setUserId($userId) {
        self::startSession();
        $this->session->set(self::USER_ID_KEY, $userId);
    }

    public function getUserId() {
        return $this->session->get(self::USER_ID_KEY);
    }

    public function setUserBranch($userBranch) {
        $this->session->set(self::USER_CPF_KEY, $userBranch);
    }

    public function getUserBranch() {
        $this->session->get(self::USER_CPF_KEY);
    }

    public function setUserClient($userClient) {
        $this->session->set(self::USER_CLIENT_KEY, $userClient);
    }

    public function getUserClient() {
        $this->session->get(self::USER_CLIENT_KEY);
    }

    public function getCurrentUserDetails() {
        return array(
            self::USER_ID_KEY => self::getUserId(),
            self::USER_CPF_KEY => self::getUserBranch(),
            self::USER_CLIENT_KEY => self::getUserClient()
        );
    }

    public function setCurrentUserDetails($userDetails) {
       self::setUserId($userDetails[self::USER_ID_KEY]);
       self::setUserBranch($userDetails[self::USER_CPF_KEY]);
       self::setUserClient($userDetails[self::USER_CLIENT_KEY]);
    }

    public function startSession(){
        $this->session->start();
    }

    public function endSession(){
        $this->session->destroy();
    }

}