<?php

namespace Service;

class ProductService {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function getProductDetails($CDPRODUTO){
        $params = array(
            ':CDPRODUTO' => $CDPRODUTO
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PRODUCT_DETAILS, $params);
        return !Empty($result) ? $result[0] : $result;
    }

    public function getProductAliquote($CDFILIAL, $CDPRODUTO){
        $params = array(
            ':CDFILIAL' =>$CDFILIAL,
            ':CDPRODUTO' => $CDPRODUTO
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_ALIQUOTA, $params);
        return !Empty($result) ? $result[0] : $result;
    }

    public function insertProduct($insertParams){
        $params = array(
            ':CDFILIAL' => $insertParams['CDFILIAL'],
            ':NRVENDAREST' => $insertParams['NRVENDAREST'],
            ':NRCOMANDA' => $insertParams['NRCOMANDA'],
            ':NRPRODCOMVEN' => $insertParams['NRPRODCOMVEN'],
            ':CDPRODUTO' => $insertParams['CDPRODUTO'],
            ':QTPRODCOMVEN' => $insertParams['QTPRODCOMVEN'],
            ':VRPRECCOMVEN' => $insertParams['VRPRECCOMVEN'],
            ':TXPRODCOMVEN' => $insertParams['TXPRODCOMVEN'],
            ':IDSTPRCOMVEN' => $insertParams['IDSTPRCOMVEN'],
            ':VRDESCCOMVEN' => $insertParams['VRDESCCOMVEN'],
            ':NRLUGARMESA' => $insertParams['NRLUGARMESA'],
            ':IDPRODIMPFIS' => $insertParams['IDPRODIMPFIS'],
            ':CDLOJA' => $insertParams['CDLOJA'],
            ':VRACRCOMVEN' => $insertParams['VRACRCOMVEN'],
            ':NRSEQPRODCOM' => $insertParams['NRSEQPRODCOM'],
            ':NRSEQPRODCUP' => $insertParams['NRSEQPRODCUP'],
            ':VRPRECCLCOMVEN' => $insertParams['VRPRECCLCOMVEN'],
            ':CDCAIXACOLETOR' => $insertParams['CDCAIXACOLETOR'],
            ':CDPRODPROMOCAO' => $insertParams['CDPRODPROMOCAO'],
            ':CDVENDEDOR' => $insertParams['CDVENDEDOR']
        );
        $this->entityManager->getConnection()->executeQuery(\Util\Query::INSERT_PRODUCT, $params);
        return true;
    }

    public function getSectorCode($CDFILIAL, $CDLOJA, $CDPRODUTO){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDLOJA' => $CDLOJA,
            ':CDPRODUTO' => $CDPRODUTO
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_SECTOR_CODE, $params);
        return !Empty($result) ? $result[0] : $result;
    }

}