<?php

namespace Service;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class SalesEmail {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function writeLog($message){
        try {
            $date = date("d-m-Y H:i:s");
            echo $date." ".$message;
            file_put_contents("../log_messages.txt", $date." ".$message."\n", FILE_APPEND);
        } catch (\Exception $e){
            echo "Erro ao criar o log: " . $e->getMessage();
        }
    }

    public function getLastRunDate() {
        try {
          $lastRunDate = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_LAST_RUN_DATE, array());
          return $lastRunDate['DTLOGEMAILVEND'];
        } catch (\Exception $e){
            $this->messagesService->writeLog("Ocorreu um erro ao buscar a data do ultimo processamento: ".$e->getMessage());
            throw new \Exception($e->getMessage());
        }
    }

    public function getSales($DTULTEXEC) {
        try {
            $params = array(
                ':DTULTEXEC' => $DTULTEXEC
            );
            return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_SALES, $params);
        } catch (\Exception $e){
            $this->messagesService->writeLog("Ocorreu um erro ao buscar os consumos dos cartões: ".$e->getMessage());
            throw new \Exception($e->getMessage());
        }
    }

    public function newCode($counterName, $size) {
        $nrseq = null;
        $connection = $this->entityManager->getConnection();
        $storedProcedure = new StoredProcedure($connection, 'NOVO_CODIGO');
        $storedProcedure->addParam(new Param('P_CONTADOR', Param::PARAM_INPUT, $counterName, Param::PARAM_TYPE_STR, strlen($counterName)));
        $storedProcedure->addParam(new Param('P_SEQUENCIAL', Param::PARAM_OUTPUT, $nrseq, Param::PARAM_TYPE_INT, 20));
        $result = $storedProcedure->execute();
        return substr($result['P_SEQUENCIAL'], strlen($result['P_SEQUENCIAL'])-$size);
    }

    public function saveLogInDataBase($NRLOGEMAILVEND, $DSLOGEMAILVEND) {
        try {
            $params = array(
                ':NRLOGEMAILVEND' => $NRLOGEMAILVEND,
                ':DSLOGEMAILVEND' => $DSLOGEMAILVEND
            );
            return $this->entityManager->getConnection()->executeQuery(\Util\Query::SAVE_LOG_IN_DATABASE, $params);
        } catch (\Exception $e){
            $this->messagesService->writeLog("Ocorreu um erro ao salvar o log: ".$e->getMessage());
            throw new \Exception($e->getMessage());
        }
    }

    public function updateLogInDataBase($NRLOGEMAILVEND, $DSLOGEMAILVEND, $IDCONCLEMAILVD) {
        try {
            $params = array(
                ':NRLOGEMAILVEND' => $NRLOGEMAILVEND,
                ':DSLOGEMAILVEND' => $DSLOGEMAILVEND,
                ':IDCONCLEMAILVD' => $IDCONCLEMAILVD
            );
            return $this->entityManager->getConnection()->executeQuery(\Util\Query::UPDATE_LOG_IN_DATABASE, $params);
        } catch (\Exception $e){
            $this->messagesService->writeLog("Ocorreu um erro ao atualizar o log: ".$e->getMessage());
            throw new \Exception($e->getMessage());
        }
    }

}