<?php

namespace Odhen\API\Lib;

class ImpressaoUtil {

    protected $util;

    public function __construct(
        \Odhen\API\Util\Util $util)  {

        $this->util = $util;
    }

    public function buscaParametrosImpressora($IDMODEIMPRES) {
        /*
        1 - Bematech Mp-20
        2 - Epson Tm-T88IIP
        3 - Bematech Mp-2100
        4 - Bematech Mp-4000
        5 - Sewoo - Chile
        6 - IBM-4610 - Colombia
        7 - Bematech MP-100 - Peru
        8 - Daruma DR600
        9 - Epson TM-U22A
        10 - Daruma DR700
        11 - Epson M244A
        12 - Zebra Tlp 2844
        13 - Bematech MP-4200
        14 - Epson TM-T88V
        16 - Epson TM-T20
        17 - Sweda SI-300S
        18 - Elgin I9
        19 - Epson TM-T88IV Ethernet
        20 - Elgin Kiosk BKT681
        23 - Custom TG2480H
        */

        switch ($IDMODEIMPRES) {
            case '1':
                // Bematech Mp-20
                $params = array(
                    'largura' => 36,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '2':
                // Epson Tm-T88IIP
                $params = array(
                    'largura' => 42,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '3':
                // Bematech Mp-2100
                $params = array(
                    'largura' => 48,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '4':
                // Bematech Mp-4000
                $params = array(
                    'largura' => 64,
                    'tipoLetra' => 1,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '5':
                // Sewoo - Chile
                $params = array(
                    'largura' => 42,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '6':
                // IBM-4610 - Colombia
                $params = array(
                    'largura' => 42,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '7':
                // Bematech MP-100 - Peru
                $params = array(
                    'largura' => 40,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '8':
                // Daruma DR600
                $params = array(
                    'largura' => 48,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '9':
                // Epson TM-U22A
                $params = array(
                    'largura' => 40,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '10':
                // Daruma DR700
                $params = array(
                    'largura' => 48,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '11':
                // Epson M244A
                $params = array(
                    'largura' => 40,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '12':
                // Zebra Tlp 2844
                $params = array(
                    'largura' => 48,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
            case '13':
                // Bematech MP-4200
                $params = array(
                    'largura' => 67,
                    'tipoLetra' => 1,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '14':
                // Epson TM-T88V
                $params = array(
                    'largura' => 40,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '16':
                // Epson TM-T20
                $params = array(
                    'largura' => 64,
                    'tipoLetra' => 1,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '17':
                // Sweda SI-300S
                $params = array(
                    'largura' => 42,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '18':
                // Elgin I9
                $params = array(
                    'largura' => 48,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '19':
                // Epson TM-T88IV Ethernet
                $params = array(
                    'largura' => 42,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(10),
                    'comandoCortePapel' => chr(27) . chr(109)
                );
                break;
            case '20':
                // 20 - Elgin Kiosk BKT681
                $params = array(
                    'largura' => 59,
                    'tipoLetra' => 2,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => null
                );
                break;
            case '23':
                // 23 - Custom TG2480H
                $params = array(
                    'largura' => 43,
                    'tipoLetra' => 1,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => chr(27) . chr(105)
                );
                break;
            default:
                $params = array(
                    'largura' => 49,
                    'tipoLetra' => 3,
                    'comandoEnter' => chr(13) . chr(10),
                    'comandoCortePapel' => chr(27) . chr(119)
                );
                break;
        }
        return $params;
    }

    public function imprimeLinha($printerParams, $text) {
        //Função criada para não deixar imprimir duas linhas em sequencia
        $linha = self::replicate('-', $printerParams['largura']) . $printerParams['comandoEnter'];
        $ultimosCaracteres = substr($text, -3);
        $parametro = '-' . $printerParams['comandoEnter'];

        if ($ultimosCaracteres == $parametro) {
            return '';
        } else {
            return $linha;
        }
    }

    public function preencheLinha($printerParams, $text, $caracter, $largura = null) {
        if (empty($largura)) {
            $largura = $printerParams['largura'];
        }
        $nrEspaços =  $largura-count($text);
        if ($nrEspaços > 0){
            $linha = $text.self::replicate($caracter, $nrEspaços) . $printerParams['comandoEnter'];
        }else{
        	$linha = $text;
        }
        return $linha;
    }

    public function preenche($largura, $text, $caracter) {
        $nrEspaços =  $largura - count($text);
        if ($nrEspaços > 0){
            $linha = $text.self::replicate($caracter, $nrEspaços);
        }else{
        	$linha = $text;
        }
        return $linha;
    }

    public function alinhaInicioFim($printerParams, $textoInicio, $textoFim) {
        $largura = $printerParams['largura'];

        $numEspacos = $largura - (strlen($textoInicio) + strlen($textoFim));
        $espaco = self::replicate(' ', $numEspacos);

        return $textoInicio . $espaco . $textoFim;
    }

    public function replicate($char, $numero){
        $result = $char;
        for ($i = 1; $i < $numero; ++$i){
            $result .= $char;
        }
        return $result;
    }

    public function centraliza($printerParams, $string, $largura = null) {
        if ($largura == null) {
            $largura = $printerParams['largura'];
        }
        $espacos = floor($largura / 2);
        $len = floor(strlen($string) / 2);
        $string = self::replicate(' ', $espacos - $len) . $string;
        return $string;
    }

    private function formataMp20($IDMODEIMPRES, $string) {
        if ($IDMODEIMPRES == '1') {
            $printerParams = self::buscaParametrosImpressora($IDMODEIMPRES);
            //Quantidade de espaços a serem dados
            for ($i = 0; $i < 4; $i++) {
                $string .= $printerParams['comandoEnter'];
            }
        }
        return $string;
    }

    public function delphiImprimePedido($text, $NRSEQIMPRLOJA, $CDSENHAPED_E_TIPO, $IDMODEIMPRES) {
        try {

            if ($this->util->isDisabledCOM()) return array('error' => false);

            $contFile = 1;

            // cria diretório onde os arquivos de impressão são salvos
            $folder = substr(__DIR__, 0, 1) . ":\\TEKNISA\\IMP\\FILES\\";
            if ($this->util->createFolder($folder)) {
                // cria arquivo de impressão
                $fileName = $folder . $NRSEQIMPRLOJA . $CDSENHAPED_E_TIPO . '.txt';
                while (file_exists($fileName)) {
                    $fileName = $folder . $NRSEQIMPRLOJA . $CDSENHAPED_E_TIPO . $contFile . '.txt';
                    $contFile = $contFile + 1;
                }

                $text = self::formataMp20($IDMODEIMPRES, $text);

                $dllCom = new \COM('Ifm.rdmPrint');
                $dllCom->CriaArquivo($fileName, $text);

                $result = array('error' => false);
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível criar o diretório de impressão, verifique as permissões.'
                );
            }
        } catch(\Exception $e) {
            $this->util->logImpressao($e->getMessage());
            $result = array(
                'error' => true,
                'message' => 'Não foi possível carregar a IFM.dll, certifique-se que ela está instalada e verifique os logs de impressão.'
            );
        }
        return $result;
    }

    public function delphiCriaArquivoImpressoras($CDFILIAL, $CDLOJA) {
        try {

            if ($this->util->isDisabledCOM())
               return array('error' => false);

            $dllCom = new \COM('Ifm.rdmPrint');
            $dllCom->Impressoras($CDFILIAL, $CDLOJA);
            return array(
                'error' => false
            );
        } catch (\Exception $e) {
            $this->util->logImpressao($e->getMessage());
            return array(
                'error' => true,
                'message' => 'Não foi possível carregar a IFM.dll, certifique-se que ela está instalada e verifique os logs de impressão.'
            );
        }
    }

    private function instanciaDllImpNF() {
        try {
            $com = new \COM('IMPNF.IMPNFClass');
            $result = array(
                'error' => false,
                'com' => $com
            );
        } catch(\Exception $e) {
            $this->util->logImpressao($e->getMessage());
            $result = array(
                'error' => true,
                'message' => 'Não foi possível instanciar a IMPNF.dll, certifique-se que ela está instalada e verifique os logs de impressão.'
            );
        }
        return $result;
    }

    public function iniciarPorta($IDMODEIMPRES, $porta) {
        try {
            $com = self::instanciaDllImpNF();
            if ($com['error'] == false) {
                $com = $com['com'];
                $result = $com->IniciaPorta($IDMODEIMPRES, $porta);
                if ($IDMODEIMPRES != 20) {
                    if ($result == 1) {
                        $result = array(
                            'error' => false,
                            'portaUsbKiosk' => 0
                        );
                    } else if ($result == -1) {
                        $result = array(
                            'error' => true,
                            'message' => 'O modelo da impressora não é aceito.',
                            'portaUsbKiosk' => 0
                        );
                    } else {
                        $result = array(
                            'error' => true,
                            'message' => 'Não foi possível iniciar a porta da impressora não fiscal.',
                            'portaUsbKiosk' => 0
                        );
                    }
                } else {
                    if ($result != -1) {
                        $result = array(
                            'error' => false,
                            'portaUsbKiosk' => $result
                        );
                    } else {
                        $result = array(
                            'error' => true,
                            'message' => 'Não foi possível iniciar a porta da impressora do totem.'
                        );
                    }
                }
            } else {
                $result = $com;
            }
        } catch(\Exception $e) {
            $this->util->logImpressao($e->getMessage());
            $result = array(
                'error' => true,
                'message' => 'Não foi possível iniciar a porta da impressora e verifique os logs de impressão.'
            );
        }
        return $result;
    }

    public function imprimeTexto($texto, $IDMODEIMPRES, $portaUsbKiosk = 0, $italico = 0, $sublinhado = 0, $expandido = 0, $enfatizado = 0, $tipoLetra = null) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            if ($tipoLetra == null) {
                $printerParams = self::buscaParametrosImpressora($IDMODEIMPRES);
                $tipoLetra = $printerParams['tipoLetra'];
            }
            $result = $com->FormataTX($IDMODEIMPRES, $texto, $tipoLetra, $italico, $sublinhado, $expandido, $enfatizado, $portaUsbKiosk);
            if ($result == 1) {
                $result = array(
                    'error' => false
                );
            } else if ($result == -1) {
                $result = array(
                    'error' => true,
                    'message' => 'O modelo da impressora não é aceito.'
                );
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível imprimir na impressora não fiscal.'
                );
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function cortaPapel($IDMODEIMPRES, $portaUsbKiosk = 0) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];

            switch ($IDMODEIMPRES) {
            	case 20:
            		$result = $com->CortaPapel($IDMODEIMPRES, $portaUsbKiosk);
            		break;
            	default:
            		$printerParams = self::buscaParametrosImpressora($IDMODEIMPRES);
	                $result = $com->FormataTX($IDMODEIMPRES, $printerParams['comandoCortePapel'], 1, 0, 0, 0, 0);
	                if ($result == 1) {
	                    $result = array(
	                        'error' => false
	                    );
	                } else if ($result == -1) {
	                    $result = array(
	                        'error' => true,
	                        'message' => 'O modelo da impressora não é aceito.'
	                    );
	                } else {
	                    $result = array(
	                        'error' => true,
	                        'message' => 'Não foi possível cortar papel na impressora não fiscal.'
	                    );
	                }
            		break;
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function fechaPorta($IDMODEIMPRES, $portaUsbKiosk = 0) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            if ($IDMODEIMPRES != 18) {
            	$result = $com->FechaPorta($IDMODEIMPRES, $portaUsbKiosk);
            } else {
            	$result = array(
                    'error' => false
                );
            }
            if ($result == 1) {
                $result = array(
                    'error' => false
                );
            } else if ($result == -1) {
                $result = array(
                    'error' => true,
                    'message' => 'O modelo da impressora não é aceito.'
                );
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível fechar a porta da impressora não fiscal.'
                );
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function configuraCodigoBarras($IDMODEIMPRES, $altura, $largura, $posicao, $fonte, $margem) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            $result = $com->ConfiguraCodigoBarras($IDMODEIMPRES, $altura, $largura, $posicao, $fonte, $margem);
            if ($result == 1) {
                $result = array(
                    'error' => false
                );
            } else if ($result == -1) {
                $result = array(
                    'error' => true,
                    'message' => 'O modelo da impressora não é aceito.'
                );
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível configurar o código de barras na impressora não fiscal.'
                );
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function imprimeCodigoBarrasCODE128($IDMODEIMPRES, $texto, $portaUsbKiosk) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            $result = $com->ImprimeCodigoBarrasCODE128($IDMODEIMPRES, $texto, $portaUsbKiosk);
            if ($result == 1) {
                $result = array(
                    'error' => false
                );
            } else if ($result == -1) {
                $result = array(
                    'error' => true,
                    'message' => 'O modelo da impressora não é aceito.'
                );
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível imprimir o código de barras na impressora não fiscal.'
                );
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function imprimeQrCode($IDMODEIMPRES, $texto, $portaUsbKiosk = 0) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            $result = $com->ImprimeCodigoQRCODE($IDMODEIMPRES, 1, 4, 0, 10, 1, $texto, $portaUsbKiosk);
            if ($result == 1) {
                $result = array(
                    'error' => false
                );
            } else if ($result == -1) {
                $result = array(
                    'error' => true,
                    'message' => 'O modelo da impressora não é aceito.'
                );
            } else {
                $result = array(
                    'error' => true,
                    'message' => 'Não foi possível imprimir o código de barras na impressora não fiscal.'
                );
            }
        } else {
            $result = $com;
        }
        return $result;
    }

    public function verificaStatusImpressora($IDMODEIMPRES) {
        $com = self::instanciaDllImpNF();
        if ($com['error'] == false) {
            $com = $com['com'];
            /*
            Retornos possíveis da função Le_Status:
            0: Erro de comunicação
            5: Impressora com pouco papel
            9: Tampa aberta
            24: Impressora "ONLINE"
            32: Impressora sem papel
            */
            $result = $com->Le_Status($IDMODEIMPRES);
        } else {
            $result = $com;
        }
        return $result;
    }

    public function formataNumero($numeroFloat, $numeroCasas) {
        return str_replace('.', ',', number_format($numeroFloat, $numeroCasas));
    }


}