<?php
namespace Zeedhi\PaymentPlatform\BankSlip;

use Zeedhi\PaymentPlatform\Address;

class StoreTest extends \PHPUnit_Framework_TestCase{
    
    /** @var Store */
    protected $store;
    /** @var String */
    protected $fancyName = "Testes Teknisa";
    /** @var Address */
    protected $storeAddress;
    /** @var StoreBankAccount */
    protected $storeBank;
    /** @var String */
    protected $webSite = "teknisa.com";
    /** @var String */
    protected $cpfCnpj = "000000000-01";
    /** @var String */
    protected $businessName = "Teknisa";
    /** @var String */
    protected $agreement = "000001";
    /** @var String */
    protected $contract = "000001";
    
    public function setUp(){
        $this->storeAddress = $this->getMockBuilder(Address::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();
                            
        $this->storeBank = $this->getMockBuilder(StoreBankAccount::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();
        
        $this->store = new Store($this->fancyName, $this->storeAddress, $this->storeBank, $this->webSite, $this->cpfCnpj, $this->businessName, $this->agreement, $this->contract);
    }
    
    public function testGetFancyName(){
        $this->assertEquals($this->fancyName, $this->store->getFancyName());
    }
    
    public function testGetStoreAddress(){
        $this->assertEquals($this->storeAddress, $this->store->getStoreAddress());
    }
    
    public function testGetStoreBank(){
        $this->assertEquals($this->storeBank, $this->store->getStoreBank());
    }
    
    public function testGetWebSite(){
        $this->assertEquals($this->webSite, $this->store->getWebSite());
    }
    
    public function testGetCpfCnpj(){
        $this->assertEquals($this->cpfCnpj, $this->store->getCpfCnpj());
    }
    
    public function testGetBusinessName(){
        $this->assertEquals($this->businessName, $this->store->getBusinessName());
    }
    
    public function testGetAgreement(){
        $this->assertEquals($this->agreement, $this->store->getAgreement());
    }
    
    public function testGetContract(){
        $this->assertEquals($this->contract, $this->store->getContract());
    }
}