# MundiPagg #

## Como utilizar

  - Utilize os arquivos dentro desta pasta para ter um exemplo de como utilizar a plataforma.

## Documentação Oficial ##

  - [MundiPagg](https://docs.mundipagg.com/reference)

## Bandeiras cartão de crédito ##

 -[Bandeiras aceitas por adquirente](https://mundipagg.zendesk.com/hc/pt-br/articles/115000213743-Bandeiras-aceitas-por-adquirente)
 
## Bancos ##

 -[Boleto bancário](https://mundipagg.zendesk.com/hc/pt-br/sections/201375743-Boleto-Banc%C3%A1rio)
 
## Adquirentes ##

 -[Adquirentes](https://mundipagg.zendesk.com/hc/pt-br/sections/201684293-Cart%C3%A3o-de-Cr%C3%A9dito)

## HTTP Status Code ##

 - Quando ocorre uma exceção na Mundipagg é retornado um código de status da requisição. Para tratar melhor o erro segue a tabela com a descrição dos códigos.

| Code | Status                  | Description                                  |
|------|-------------------------|----------------------------------------------|
| 200  | OK                      | Sucesso |                                    |
| 400  | Bad Request             | Requisição inválida                          |
| 401  | Unauthorized            | Chave de API inválida                        |
| 404  | Not Found               | O recurso solicitado não existe              |
| 412  | Precondition Failed     | Parâmetros válidos mas a requisição falhou   |
| 422  | Unprocessable Entity    | Parâmetros inválidos                         |
| 500  | Internal Server Error   | Ocorreu um erro interno                      |

## Consultando transações ##

* Quando uma transação é realizada você pode consultar todos os dados através do método `consult`.
* (IMPORTANTE) Após realizar uma transação utilize o id de retorno para consulta. Verifique o código da adquirente, a mensagem e o campo success para saber o status da transação.
* O json abaixo passa por um decode, para acessar os campos você pode consultar como array. (Ex.: `$response["id"]`, `$response["customer"]["id"]`).

#### Os campos mais importantes são: ####

* `$response["id"]`                                       - Id da transação.
* `$response["customer"]["id"]`                           - Id do cliente.
* `$response["last_transaction"]["success"]`              - Informação sobre o status da transação (`true` or `false`).
* `$response["last_transaction"]["acquirer_return_code"]` - Código da adquirente.
* `$response["last_transaction"]["acquirer_message"]`     - Mensagem da adquirente.

Segue o exemplo:
```json
{
  "id": "ch_EQ9mMrPf7Sl0k1aJ",
  "code": "3P97SVQSEG",
  "gateway_id": "d3149c5e-b244-4d5b-921a-262e62c23842",
  "amount": 1490,
  "status": "paid",
  "currency": "BRL",
  "payment_method": "credit_card",
  "paid_at": "2017-04-20T22:34:49Z",
  "created_at": "2017-04-20T22:34:46Z",
  "updated_at": "2017-04-20T22:34:46Z",
  "customer": {
    "id": "cus_owk0aXqYCBuA4GOR",
    "name": "Luke Skywalker",
    "email": "lskywalker@r2d2.com",
    "delinquent": false,
    "created_at": "2017-04-20T22:34:46Z",
    "updated_at": "2017-04-20T22:34:46Z"
  },
  "last_transaction": {
    "id": "tran_G1ONw9gsrOFo5YzK",
    "transaction_type": "credit_card",
    "gateway_id": "2bd2c33f-2cdd-4253-8cdd-dc065647e497",
    "amount": 1490,
    "status": "captured",
    "success": true,
    "installments": 1,
    "statement_descriptor": "Spotify",
    "acquirer_name": "simulator",
    "acquirer_affiliation_code": "MUNDI",
    "acquirer_tid": "959021",
    "acquirer_nsu": "969160",
    "acquirer_auth_code": "348260",
    "acquirer_message": "Stone|Transação autorizada com sucesso",
    "acquirer_return_code": "0",
    "operation_type": "auth_and_capture",
    "card": {
      "id": "card_0DAZr93hKqUWyd7B",
      "first_six_digits": "342793",
      "last_four_digits": "5322",
      "brand": "Visa",
      "holder_name": "Luke Skywalker",
      "exp_month": 5,
      "exp_year": 2017,
      "status": "active",
      "created_at": "2017-04-20T22:34:46Z",
      "updated_at": "2017-04-20T22:34:46Z",
      "billing_address": {
        "street": "Av. General Justo",
        "number": "375",
        "complement": "9º andar",
        "zip_code": "20021130",
        "neighborhood": "Centro",
        "city": "Rio de Janeiro",
        "state": "RJ",
        "country": "BR"
      },
      "type": "credit"
    },
    "created_at": "2017-04-20T22:34:46Z",
    "updated_at": "2017-04-20T22:34:46Z",
    "gateway_response": {
      "code": "201"
    }
  },
  "metadata": {
    "id": "something"
  }
}
```