describe("DashboardController", function(){

    var dashboardController, scopeMock, controller, screenService, templateManager;
    window.templateUrls = [{
        package: "default",
        baseUrl: ""
    }];

    beforeEach(function() {
        module("ZeedhiApp");
        inject(function($rootScope, $controller) {
            screenService = ScreenService;
            templateManager = TemplateManager;

            scopeMock = $rootScope.$new();

            controller = $controller;
        });
    });

    it("Should have a floating control", function() {
        scopeMock.widget = {
            floatingControl: undefined
        };
        dashboardController = controller("DashboardController", {
            $scope: scopeMock,
            timeout: {},
            ScreenService: {
                i18n: function(word) {return word;}
            },
            templateManager: templateManager
        });

        expect(!!scopeMock.widget.floatingControl).toBe(true);
    });

    it("Should not have a floating control", function() {
        scopeMock.widget = {
            floatingControl: false
        };
        dashboardController = controller("DashboardController", {
            $scope: scopeMock,
            timeout: {},
            ScreenService: {
                i18n: function(word) {return word;}
            },
            templateManager: templateManager
        });

        expect(scopeMock.widget.floatingControl).toBe(false);
    });
});