## Zeedhi Customizations Preferences

zh-customization-preferences is a library to apply customizations on Zeedhi's grids. This customziations are filters connected with layouts.

You can start following the steps below:

 - Be sure you already injected zh-customizations-service

 - Add on your project bower.json file the dependency

  - Example:

```javascript
    "dependencies": {
        "zh-customizations-service": "*",
        "zh-customization-preferences": "*"
    }
```
 - Run `bower install`

 - Inject the library on your index.html project file

   - Example:

```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-customization-preferences/dist/zhCustomizationsPreferences.js"></script>
```
 Or the minified version
 ```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-customization-preferences/dist/zhCustomizationsPreferences.min.js"></script>
```

### How to use:
- To create a an action on your widget floating button you should have the property FloatingControl of your widget structured like this:

```javascript
"floatingControl": {
	"customizationAction": {
		"layout": false,
		"filter": false,
		"view" : true
	}
}
```
 - Pay attention on your `view` property, it needs to be true;

- To open the customizations configurations popup wherever you want you can inject it on your controller as `zhCustomizationPreferences` and call the method `startViewSettings` from it passing your widget as parameter.
  - Example:

```javascript
"events": [
    {
        "name": "ActionEvent",
        "code": "zhCustomizationPreferences.startViewSettings(yourGridWidget)",
        "id": "1589480891951sdasd848201320"
    }
]
```
