## Zeedhi Layout Preferences

zh-layout-preferences is a library to apply layout preferences on Zeedhi's grids.

You can start following the steps below:

 - Be sure you already injected zh-customizations-service

 - Add on your project bower.json file the dependency

  - Example:

```javascript
    "dependencies": {
        "zh-customizations-service": "*",
        "zh-layout-preferences": "*"
    }
```
 - Run `bower install`

 - Inject the library on your index.html project file.

   - Example:

```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-layout-preferences/dist/zhLayoutPreferences.js"></script>
```
 Or the minified version
```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-layout-preferences/dist/zhLayoutPreferences.min.js"></script>
```

### How to use:
- To create a an action on your widget floating button you should have the property FloatingControl of your widget structured like this:

```javascript
"floatingControl": {
    "draggable": true,
    "searchAction": true,
    "customizationAction": {
        "layout": true,
        "filter": false,
        "view" : false
    }
}
```
 - Pay attention on your `layout` property, it needs to be true;

- To open the layout configurations popup wherever you want you cant Inject on your controller `zhLayoutPreferencesController` and call the method `startConfig` from it passing your widget as parameter.
  - Example:

```javascript
"events": [
    {
        "name": "ActionEvent",
        "code": "zhLayoutPreferencesController.startConfig(yourGridWidget)",
        "id": "1589480891951sdasd848201320"
    }
]
```
### Options:

> It is possible to hide some field from layout customizations by setting `skipPreference` to true