function BlockCardController(ScreenService, BlockCardService, LoginRepository, CardStatusRepository){

    /* Gets the consumer's card status and sets up the page accordingly. */
    this.getCardStatus = function(widget){
        LoginRepository.findOne().then(function (consumerData){
            BlockCardService.getCardStatus(consumerData['CDCONSUMIDOR'], consumerData['CDCLIENTE']).then(function (cardData){
                /* Card status is represented with numbers. */
                /*      1 - unblocked      2 - blocked      */
                var message = {
                    'blocked': '',
                    'unblocked': ''
                };
                switch(localStorage.getItem('lang')){
                    case 'pt_br':
                        message['blocked'] = 'bloqueado';
                        message['unblocked'] = 'desbloqueado';
                        break;
                    case 'en_us':
                        message['blocked'] = 'blocked';
                        message['unblocked'] = 'unblocked';
                        break;
                    case 'es':
                        message['blocked'] = 'obstruido';
                        message['unblocked'] = 'desbloqueado';
                        break;
                    default:
                        message['blocked'] = 'bloqueado';
                        message['unblocked'] = 'desbloqueado';
                        break;
                }
                if (cardData[0]['IDSITCONSUMI'] === '1'){
                    widget.fields[1].text = message['unblocked'];
                    widget.fields[2].label = 'Deseja bloquear o cartão?';
                }
                else {
                    widget.fields[1].text = message['blocked'];
                    widget.fields[2].label = 'Deseja desbloquear o cartão?';
                }
                widget.currentRow['status'] = widget.fields[1].text;
            });
        });
    };

    /* Toggles the consumer's card status between blocked and unblocked. */
    this.toggleBlock = function(){
        LoginRepository.findOne().then(function (consumerData){
            CardStatusRepository.findOne().then(function (cardStatus){
                var IDSITCONSUMI = null;
                var msg = "";
                if (cardStatus['IDSITCONSUMI'] == '1'){
                    /* Block card. */
                    IDSITCONSUMI = '2';
                    msg = "O cartão foi bloqueado.";
                }
                else {
                    /* Unblock card. */
                    IDSITCONSUMI = '1';
                    msg = "O cartão foi desbloqueado.";
                }

                BlockCardService.toggleBlock(IDSITCONSUMI, consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR']).then(function (){
                    ScreenService.showMessage(msg);
                    ScreenService.goBack();
                });
            });
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('BlockCardController', BlockCardController);
});
