function ConsumersController(templateManager, ConsumersRepository, ConsumersService, Query, metaDataFactory, LoginRepository, ZHPromise, LayoutRepo, LoginService, Utilities, ProfileService, ScreenService, ConsumerDetailsRepository){

    self = this;

    this.dashboardMethods = function (container){
        var menuGroups = templateManager.project.groupMenu;
        menuGroups[1].menus[0].isVisible = false;
        menuGroups[1].menus[1].isVisible = false;
        menuGroups[1].menus[2].isVisible = false;
        menuGroups[1].menus[3].isVisible = false;
        menuGroups[1].menus[4].isVisible = false;
        menuGroups[1].menus[5].isVisible = false;
        LoginRepository.findOne().then(function (consumerData){
            if (consumerData){
                ProfileService.getConsumerDetails(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], consumerData['CDFILIAL']).then(function (parentData){
                    var isParentDataOk = self.checkParentData(parentData);

                    if(!isParentDataOk){
                        ProfileService.setOpenEdit(true);
                        menuGroups[1].menus[0].isVisible = false;
                        menuGroups[1].menus[1].isVisible = false;
                        menuGroups[1].menus[2].isVisible = false;
                        menuGroups[1].menus[3].isVisible = false;
                        menuGroups[1].menus[4].isVisible = false;
                        menuGroups[1].menus[5].isVisible = false;
                        ScreenService.showMessage("É necessário completar os dados de cadastro antes de utilizar o aplicativo!");
                        ScreenService.openWindow('profile');
                    } else{
                        container.label = consumerData['NMRESPCONS'];
                        var lang = window.lang;
                        ConsumersService.reloadConsumers(consumerData['CDCLIENTE'], consumerData['NRCPFRESPCON'], lang, consumerData['CDFILIAL']).then(function (consumers){
                            self.resetDynamicWidgets(container.widgets).then(function(widgets){
                                self.updateTemplate().then(function (){
                                    self.buildConsumers(consumers, container, consumerData);
                                    templateManager.updateTemplate();
                                });
                            });
                        });
                    }
                });
            }
        });
    };

    this.checkParentData = function(parentData){
        var isDataOk = true;
        if(parentData[0].NMRESPCONS === null){
            isDataOk = false;
        } else if(parentData[0].NRCPFRESPCON === null){
            isDataOk = false;
        } else if(parentData[0].DSEMAILCONS === null){
            isDataOk = false;
        } else if(parentData[0].NRCELULARCONS === null){
            isDataOk = false;
        } else if(parentData[0].DSENDECONS === null){
            isDataOk = false;
        } else if(parentData[0].NRENDECONS === null){
            isDataOk = false;
        } else if(parentData[0].NRCEPCONS === null){
            isDataOk = false;
        } else if(parentData[0].SGESTADO === null){
            isDataOk = false;
        } else if(parentData[0].NMMUNICIPIO === null){
            isDataOk = false;
        }
        return isDataOk;
    };

    this.buildConsumers = function(consumers, container, consumerData){
        for (var i = 0; i < consumers.length; ++i){

            var id = parseInt(i)+1;
            var color = 10 + (id % 4);

            var widgetJson = this.buildNewWidget(consumers[i], color, container, id);
            var widget = metaDataFactory.widgetFactory(widgetJson, container);
            container.widgets.push(widget);
        }
        ConsumerDetailsRepository.findOne()
        .then(function(consumerData){
            if(consumerData.HABENVNOTIF === 'S'){
                var notificationWidgetJson = self.buildNotificationsWidget(consumers[0], 3, container, 50);
                var notificationWidget = metaDataFactory.widgetFactory(notificationWidgetJson, container);
                container.widgets.push(notificationWidget);     
            }
        });
        LayoutRepo.findOne()
        .then(function(layout){
            if(!layout){
                LoginService.getLayoutConfig(consumerData.CDCLIENTE, consumerData.CDTIPOCONS, consumerData.CDFILIAL)
                .then(function(layout){
                    loadLayoutConfig(container, layout[0]);
                });
            } else{
                loadLayoutConfig(container, layout);
            }
            templateManager.updateTemplate();
        });
    };

    var loadLayoutConfig = function(container, layout){
        var menuGroups = templateManager.project.groupMenu;
        var client = Utilities.getClientApp();
        var lang = window.lang;

        if(layout.RECARREGACARTAO === 'S'){
            var widgetJson1;
            if(lang == 'en_us'){
                widgetJson1 = self.rechargeWizardWidgetEn;
            } else if(lang == 'es'){
                widgetJson1 = self.rechargeWizardWidgetEs;
            } else{
                widgetJson1 = self.rechargeWizardWidget;
            }
            var rechargeWizardWidget = metaDataFactory.widgetFactory(widgetJson1, container);
            container.widgets.push(rechargeWizardWidget);
            menuGroups[1].menus[0].isVisible = true;
        }
        if(layout.ATUALIZACADASTRO === 'S'){
            var widgetJson2 = self.profileWidget;
            var profileWidget = metaDataFactory.widgetFactory(widgetJson2, container);
            container.widgets.push(profileWidget);
            menuGroups[1].menus[3].isVisible = true;
        }
        if(layout.FALECONOSCO === 'S'){
            if(client === 'sapore'){
                var widgetJson3 = self.speakToUsWidget;
                var speakToUsWidget = metaDataFactory.widgetFactory(widgetJson3, container);
                container.widgets.push(speakToUsWidget);
            }
            menuGroups[1].menus[2].isVisible = true;
        }
        if(layout.EDITACARTAO === 'S'){
            var widgetJson4 = self.cardsWidget;
            var cardsWidget = metaDataFactory.widgetFactory(widgetJson4, container);
            container.widgets.push(cardsWidget);
        }
        if(layout.VISUALIZACARDAPIO === 'S'){
            var widgetJson5 = self.menuWidget;
            var menuWidget = metaDataFactory.widgetFactory(widgetJson5, container);
            container.widgets.push(menuWidget);
        }
        if(layout.TROCASENHA === 'S'){
            menuGroups[1].menus[4].isVisible = true;
        }
        
        ConsumerDetailsRepository.findOne()
        .then(function(consumerData){
            if(consumerData.HABENVNOTIF === 'S'){
                menuGroups[1].menus[5].isVisible = true;
            } else{
                menuGroups[1].menus[5].isVisible = false;
            }
        });
    }

    this.buildNewWidget = function(consumer, color, container, id){
        var newLabel =
        {
            "id": id,
            "width": "100%",
            "height": 1,
            "color": color,
            "CDCONSUMIDOR" : consumer['CDCONSUMIDOR'],
            "CDCLIENTE" : consumer['CDCLIENTE'],
            "name": "cardConsumer"+id,
            "label": consumer['NMCONSUMIDOR'],
            "notification": consumer['VRSALDCONFAM'],
            "isVisible": true,
            "icon": "money-sign",
            "template": "noCashTemplates#custom_notification_shortcut.html",
            "events": [
                {
                    "id": 1,
                    "name": "WidgetOnDashboardClick",
                    "code": "ProfileController.getCurrentConsumerDetails(args.owner, args.owner); ProfileController.notHandleMenus();"
                }
            ],
            "dataSourceFilter": [
                {
                    "name": "CDCLIENTE",
                    "value": "widget.parent.currentRow.CDCLIENTE",
                    "operator": "="
                },
                {
                    "name": "CDCONSUMIDOR",
                    "value": "widget.parent.currentRow.CDCONSUMIDOR",
                    "operator": "="
                }
            ],
            "dataSource": {
                "lazyLoad": true,
                "localStorage": false,
                "rest": true,
                "name": "/BalanceRepository"
            },
            "fields": []
        }
        return newLabel;
    };

    this.buildNotificationsWidget = function(consumer, color, container, id){
        var newLabel =
        {
            "id": id,
            "width": "100%",
            "height": 1,
            "color": color,
            "CDCONSUMIDOR" : consumer['CDCONSUMIDOR'],
            "CDCLIENTE" : consumer['CDCLIENTE'],
            "name": "cardConsumer"+id,
            "label": "Notificações",
            "notification": consumer['NRNOTIFNAOLIDA'],
            "isVisible": true,
            "icon": "exclamation",
            "template": "noCashTemplates#custom_notification_shortcut.html",
            "events": [
                {
                    "id": 1,
                    "name": "WidgetOnDashboardClick",
                    "code": "ScreenService.openWindow('notification')"
                }
            ],
            "fields": []
        }
        return newLabel;
    };

    this.rechargeWizardWidget = {
                "id": 120,
                "width": "50%",
                "height": 1,
                "color": 1,
                "name": "recarregar cartão",
                "label": "Recarregar Cartão",
                "windowName": "rechargeWizard",
                "isVisible": true,
                "icon": "money-charge",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.rechargeWizardWidgetEn = {
                "id": 120,
                "width": "50%",
                "height": 1,
                "color": 1,
                "name": "recarregar cartão",
                "label": "Recharge Card",
                "windowName": "rechargeWizard",
                "isVisible": true,
                "icon": "money-sign",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.rechargeWizardWidgetEs = {
                "id": 120,
                "width": "50%",
                "height": 1,
                "color": 1,
                "name": "recarregar cartão",
                "label": "Recargar Tarjeta",
                "windowName": "rechargeWizard",
                "isVisible": true,
                "icon": "money-sign",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.profileWidget = {
                "id": 125,
                "width": "50%",
                "height": 1,
                "color": 2,
                "name": "profile",
                "label": "Perfil",
                "windowName": "profile",
                "isVisible": true,
                "icon": "person",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.speakToUsWidget = {
                "id": 130,
                "width": "100%",
                "height": 1,
                "color": 3,
                "name": "speakToUs",
                "label": "Fale Conosco",
                "windowName": "speakToUs",
                "isVisible": true,
                "icon": "question",
                "template": "../../../../templates/speakToUsShortcut.html",
                "fields": []
    };

    this.cardsWidget = {
                "id": 135,
                "width": "100%",
                "height": 1,
                "color": 6,
                "name": "creditCardList",
                "label": "Meus Cartões",
                "windowName": "creditCardList",
                "isVisible": true,
                "icon": "credit-card",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.menuWidget = {
                "id": 136,
                "width": "100%",
                "height": 1,
                "color": 4,
                "name": "storesMenu",
                "label": "Cardápio",
                "windowName": "selectStore",
                "isVisible": true,
                "icon": "price-tag",
                "template": "widget/dashboard/menu-shortcut.html",
                "fields": []
    };

    this.resetDynamicWidgets = function(widgets){
        var defer = ZHPromise.defer();
        for (index = widgets.length-1; index >= 0 ; index--){
            widgets.splice(index, 1);
        };
        defer.resolve(widgets);
        return defer.promise;
    };

    this.updateTemplate = function(){
        var defer = ZHPromise.defer();
        templateManager.updateTemplate();
        defer.resolve();
        return defer.promise;
    };

    this.getCurrentConsumerName = function (){
            LoginRepository.findOne().then(function (ConsumerData){
            container.label = ConsumerData.NMCONSUMIDOR;
        });
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('ConsumersController', ConsumersController);
});